Responses
Create a model response
post /responses
Creates a model response. Provide text or image inputs to generate text or JSON outputs. Have the model call your own custom code or use built-in tools like web search or file search to use your own data as input for the model's response.
Body Parameters
-
background: optional booleanWhether to run the model response in the background. Learn more.
-
context_management: optional array of object { type, compact_threshold }Context management configuration for this request.
-
type: stringThe context management entry type. Currently only 'compaction' is supported.
-
compact_threshold: optional numberToken threshold at which compaction should be triggered for this entry.
-
-
conversation: optional string or ResponseConversationParamThe conversation that this response belongs to. Items from this conversation are prepended to
input_itemsfor this response request. Input items and output items from this response are automatically added to this conversation after this response completes.-
ConversationID = stringThe unique ID of the conversation.
-
ResponseConversationParam object { id }The conversation that this response belongs to.
-
id: stringThe unique ID of the conversation.
-
-
-
include: optional array of ResponseIncludableSpecify additional output data to include in the model response. Currently supported values are:
-
web_search_call.action.sources: Include the sources of the web search tool call. -
code_interpreter_call.outputs: Includes the outputs of python code execution in code interpreter tool call items. -
computer_call_output.output.image_url: Include image urls from the computer call output. -
file_search_call.results: Include the search results of the file search tool call. -
message.input_image.image_url: Include image urls from the input message. -
message.output_text.logprobs: Include logprobs with assistant messages. -
reasoning.encrypted_content: Includes an encrypted version of reasoning tokens in reasoning item outputs. This enables reasoning items to be used in multi-turn conversations when using the Responses API statelessly (like when thestoreparameter is set tofalse, or when an organization is enrolled in the zero data retention program). -
"file_search_call.results" -
"web_search_call.results" -
"web_search_call.action.sources" -
"message.input_image.image_url" -
"computer_call_output.output.image_url" -
"code_interpreter_call.outputs" -
"reasoning.encrypted_content" -
"message.output_text.logprobs"
-
-
input: optional string or array of EasyInputMessage or object { content, role, status, type } or ResponseOutputMessage or 26 moreText, image, or file inputs to the model, used to generate a response.
Learn more:
-
TextInput = stringA text input to the model, equivalent to a text input with the
userrole. -
InputItemList = array of EasyInputMessage or object { content, role, status, type } or ResponseOutputMessage or 26 moreA list of one or many input items to the model, containing different content types.
-
EasyInputMessage object { content, role, phase, type }A message input to the model with a role indicating instruction following hierarchy. Instructions given with the
developerorsystemrole take precedence over instructions given with theuserrole. Messages with theassistantrole are presumed to have been generated by the model in previous interactions.-
content: string or ResponseInputMessageContentListText, image, or audio input to the model, used to generate a response. Can also contain previous assistant responses.
-
TextInput = stringA text input to the model.
-
ResponseInputMessageContentList = array of ResponseInputContentA list of one or many input items to the model, containing different content types.
-
ResponseInputText object { text, type }A text input to the model.
-
text: stringThe text input to the model.
-
type: "input_text"The type of the input item. Always
input_text."input_text"
-
-
ResponseInputImage object { detail, type, file_id, image_url }An image input to the model. Learn about image inputs.
-
detail: "low" or "high" or "auto" or "original"The detail level of the image to be sent to the model. One of
high,low,auto, ororiginal. Defaults toauto.-
"low" -
"high" -
"auto" -
"original"
-
-
type: "input_image"The type of the input item. Always
input_image."input_image"
-
file_id: optional stringThe ID of the file to be sent to the model.
-
image_url: optional stringThe URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.
-
-
ResponseInputFile object { type, detail, file_data, 3 more }A file input to the model.
-
type: "input_file"The type of the input item. Always
input_file."input_file"
-
detail: optional "low" or "high"The detail level of the file to be sent to the model. Use
lowfor the default rendering behavior, orhighto render the file at higher quality. Defaults tolow.-
"low" -
"high"
-
-
file_data: optional stringThe content of the file to be sent to the model.
-
file_id: optional stringThe ID of the file to be sent to the model.
-
file_url: optional stringThe URL of the file to be sent to the model.
-
filename: optional stringThe name of the file to be sent to the model.
-
-
-
-
role: "user" or "assistant" or "system" or "developer"The role of the message input. One of
user,assistant,system, ordeveloper.-
"user" -
"assistant" -
"system" -
"developer"
-
-
phase: optional "commentary" or "final_answer"Labels an
assistantmessage as intermediate commentary (commentary) or the final answer (final_answer). For models likegpt-5.3-codexand beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.-
"commentary" -
"final_answer"
-
-
type: optional "message"The type of the message input. Always
message."message"
-
-
Message object { content, role, status, type }A message input to the model with a role indicating instruction following hierarchy. Instructions given with the
developerorsystemrole take precedence over instructions given with theuserrole.-
content: ResponseInputMessageContentListA list of one or many input items to the model, containing different content types.
-
role: "user" or "system" or "developer"The role of the message input. One of
user,system, ordeveloper.-
"user" -
"system" -
"developer"
-
-
status: optional "in_progress" or "completed" or "incomplete"The status of item. One of
in_progress,completed, orincomplete. Populated when items are returned via API.-
"in_progress" -
"completed" -
"incomplete"
-
-
type: optional "message"The type of the message input. Always set to
message."message"
-
-
ResponseOutputMessage object { id, content, role, 3 more }An output message from the model.
-
id: stringThe unique ID of the output message.
-
content: array of ResponseOutputText or ResponseOutputRefusalThe content of the output message.
-
ResponseOutputText object { annotations, logprobs, text, type }A text output from the model.
-
annotations: array of object { file_id, filename, index, type } or object { end_index, start_index, title, 2 more } or object { container_id, end_index, file_id, 3 more } or object { file_id, index, type }The annotations of the text output.
-
FileCitation object { file_id, filename, index, type }A citation to a file.
-
file_id: stringThe ID of the file.
-
filename: stringThe filename of the file cited.
-
index: numberThe index of the file in the list of files.
-
type: "file_citation"The type of the file citation. Always
file_citation."file_citation"
-
-
URLCitation object { end_index, start_index, title, 2 more }A citation for a web resource used to generate a model response.
-
end_index: numberThe index of the last character of the URL citation in the message.
-
start_index: numberThe index of the first character of the URL citation in the message.
-
title: stringThe title of the web resource.
-
type: "url_citation"The type of the URL citation. Always
url_citation."url_citation"
-
url: stringThe URL of the web resource.
-
-
ContainerFileCitation object { container_id, end_index, file_id, 3 more }A citation for a container file used to generate a model response.
-
container_id: stringThe ID of the container file.
-
end_index: numberThe index of the last character of the container file citation in the message.
-
file_id: stringThe ID of the file.
-
filename: stringThe filename of the container file cited.
-
start_index: numberThe index of the first character of the container file citation in the message.
-
type: "container_file_citation"The type of the container file citation. Always
container_file_citation."container_file_citation"
-
-
FilePath object { file_id, index, type }A path to a file.
-
file_id: stringThe ID of the file.
-
index: numberThe index of the file in the list of files.
-
type: "file_path"The type of the file path. Always
file_path."file_path"
-
-
-
logprobs: array of object { token, bytes, logprob, top_logprobs }-
token: string -
bytes: array of number -
logprob: number -
top_logprobs: array of object { token, bytes, logprob }-
token: string -
bytes: array of number -
logprob: number
-
-
-
text: stringThe text output from the model.
-
type: "output_text"The type of the output text. Always
output_text."output_text"
-
-
ResponseOutputRefusal object { refusal, type }A refusal from the model.
-
refusal: stringThe refusal explanation from the model.
-
type: "refusal"The type of the refusal. Always
refusal."refusal"
-
-
-
role: "assistant"The role of the output message. Always
assistant."assistant"
-
status: "in_progress" or "completed" or "incomplete"The status of the message input. One of
in_progress,completed, orincomplete. Populated when input items are returned via API.-
"in_progress" -
"completed" -
"incomplete"
-
-
type: "message"The type of the output message. Always
message."message"
-
phase: optional "commentary" or "final_answer"Labels an
assistantmessage as intermediate commentary (commentary) or the final answer (final_answer). For models likegpt-5.3-codexand beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.-
"commentary" -
"final_answer"
-
-
-
FileSearchCall object { id, queries, status, 2 more }The results of a file search tool call. See the file search guide for more information.
-
id: stringThe unique ID of the file search tool call.
-
queries: array of stringThe queries used to search for files.
-
status: "in_progress" or "searching" or "completed" or 2 moreThe status of the file search tool call. One of
in_progress,searching,incompleteorfailed,-
"in_progress" -
"searching" -
"completed" -
"incomplete" -
"failed"
-
-
type: "file_search_call"The type of the file search tool call. Always
file_search_call."file_search_call"
-
results: optional array of object { attributes, file_id, filename, 2 more }The results of the file search tool call.
-
attributes: optional map[string or number or boolean]Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters, booleans, or numbers.
-
string -
number -
boolean
-
-
file_id: optional stringThe unique ID of the file.
-
filename: optional stringThe name of the file.
-
score: optional numberThe relevance score of the file - a value between 0 and 1.
-
text: optional stringThe text that was retrieved from the file.
-
-
-
ComputerCall object { id, call_id, pending_safety_checks, 4 more }A tool call to a computer use tool. See the computer use guide for more information.
-
id: stringThe unique ID of the computer call.
-
call_id: stringAn identifier used when responding to the tool call with output.
-
pending_safety_checks: array of object { id, code, message }The pending safety checks for the computer call.
-
id: stringThe ID of the pending safety check.
-
code: optional stringThe type of the pending safety check.
-
message: optional stringDetails about the pending safety check.
-
-
status: "in_progress" or "completed" or "incomplete"The status of the item. One of
in_progress,completed, orincomplete. Populated when items are returned via API.-
"in_progress" -
"completed" -
"incomplete"
-
-
type: "computer_call"The type of the computer call. Always
computer_call."computer_call"
-
action: optional ComputerActionA click action.
-
Click object { button, type, x, 2 more }A click action.
-
button: "left" or "right" or "wheel" or 2 moreIndicates which mouse button was pressed during the click. One of
left,right,wheel,back, orforward.-
"left" -
"right" -
"wheel" -
"back" -
"forward"
-
-
type: "click"Specifies the event type. For a click action, this property is always
click."click"
-
x: numberThe x-coordinate where the click occurred.
-
y: numberThe y-coordinate where the click occurred.
-
keys: optional array of stringThe keys being held while clicking.
-
-
DoubleClick object { keys, type, x, y }A double click action.
-
keys: array of stringThe keys being held while double-clicking.
-
type: "double_click"Specifies the event type. For a double click action, this property is always set to
double_click."double_click"
-
x: numberThe x-coordinate where the double click occurred.
-
y: numberThe y-coordinate where the double click occurred.
-
-
Drag object { path, type, keys }A drag action.
-
path: array of object { x, y }An array of coordinates representing the path of the drag action. Coordinates will appear as an array of objects, eg
[ { x: 100, y: 200 }, { x: 200, y: 300 } ]-
x: numberThe x-coordinate.
-
y: numberThe y-coordinate.
-
-
type: "drag"Specifies the event type. For a drag action, this property is always set to
drag."drag"
-
keys: optional array of stringThe keys being held while dragging the mouse.
-
-
Keypress object { keys, type }A collection of keypresses the model would like to perform.
-
keys: array of stringThe combination of keys the model is requesting to be pressed. This is an array of strings, each representing a key.
-
type: "keypress"Specifies the event type. For a keypress action, this property is always set to
keypress."keypress"
-
-
Move object { type, x, y, keys }A mouse move action.
-
type: "move"Specifies the event type. For a move action, this property is always set to
move."move"
-
x: numberThe x-coordinate to move to.
-
y: numberThe y-coordinate to move to.
-
keys: optional array of stringThe keys being held while moving the mouse.
-
-
Screenshot object { type }A screenshot action.
-
type: "screenshot"Specifies the event type. For a screenshot action, this property is always set to
screenshot."screenshot"
-
-
Scroll object { scroll_x, scroll_y, type, 3 more }A scroll action.
-
scroll_x: numberThe horizontal scroll distance.
-
scroll_y: numberThe vertical scroll distance.
-
type: "scroll"Specifies the event type. For a scroll action, this property is always set to
scroll."scroll"
-
x: numberThe x-coordinate where the scroll occurred.
-
y: numberThe y-coordinate where the scroll occurred.
-
keys: optional array of stringThe keys being held while scrolling.
-
-
Type object { text, type }An action to type in text.
-
text: stringThe text to type.
-
type: "type"Specifies the event type. For a type action, this property is always set to
type."type"
-
-
Wait object { type }A wait action.
-
type: "wait"Specifies the event type. For a wait action, this property is always set to
wait."wait"
-
-
-
actions: optional ComputerActionListFlattened batched actions for
computer_use. Each action includes antypediscriminator and action-specific fields.-
Click object { button, type, x, 2 more }A click action.
-
DoubleClick object { keys, type, x, y }A double click action.
-
Drag object { path, type, keys }A drag action.
-
Keypress object { keys, type }A collection of keypresses the model would like to perform.
-
Move object { type, x, y, keys }A mouse move action.
-
Screenshot object { type }A screenshot action.
-
Scroll object { scroll_x, scroll_y, type, 3 more }A scroll action.
-
Type object { text, type }An action to type in text.
-
Wait object { type }A wait action.
-
-
-
ComputerCallOutput object { call_id, output, type, 3 more }The output of a computer tool call.
-
call_id: stringThe ID of the computer tool call that produced the output.
-
output: ResponseComputerToolCallOutputScreenshotA computer screenshot image used with the computer use tool.
-
type: "computer_screenshot"Specifies the event type. For a computer screenshot, this property is always set to
computer_screenshot."computer_screenshot"
-
file_id: optional stringThe identifier of an uploaded file that contains the screenshot.
-
image_url: optional stringThe URL of the screenshot image.
-
-
type: "computer_call_output"The type of the computer tool call output. Always
computer_call_output."computer_call_output"
-
id: optional stringThe ID of the computer tool call output.
-
acknowledged_safety_checks: optional array of object { id, code, message }The safety checks reported by the API that have been acknowledged by the developer.
-
id: stringThe ID of the pending safety check.
-
code: optional stringThe type of the pending safety check.
-
message: optional stringDetails about the pending safety check.
-
-
status: optional "in_progress" or "completed" or "incomplete"The status of the message input. One of
in_progress,completed, orincomplete. Populated when input items are returned via API.-
"in_progress" -
"completed" -
"incomplete"
-
-
-
WebSearchCall object { id, action, status, type }The results of a web search tool call. See the web search guide for more information.
-
id: stringThe unique ID of the web search tool call.
-
action: object { query, type, queries, sources } or object { type, url } or object { pattern, type, url }An object describing the specific action taken in this web search call. Includes details on how the model used the web (search, open_page, find_in_page).
-
Search object { query, type, queries, sources }Action type "search" - Performs a web search query.
-
query: string[DEPRECATED] The search query.
-
type: "search"The action type.
"search"
-
queries: optional array of stringThe search queries.
-
sources: optional array of object { type, url }The sources used in the search.
-
type: "url"The type of source. Always
url."url"
-
url: stringThe URL of the source.
-
-
-
OpenPage object { type, url }Action type "open_page" - Opens a specific URL from search results.
-
type: "open_page"The action type.
"open_page"
-
url: optional stringThe URL opened by the model.
-
-
FindInPage object { pattern, type, url }Action type "find_in_page": Searches for a pattern within a loaded page.
-
pattern: stringThe pattern or text to search for within the page.
-
type: "find_in_page"The action type.
"find_in_page"
-
url: stringThe URL of the page searched for the pattern.
-
-
-
status: "in_progress" or "searching" or "completed" or "failed"The status of the web search tool call.
-
"in_progress" -
"searching" -
"completed" -
"failed"
-
-
type: "web_search_call"The type of the web search tool call. Always
web_search_call."web_search_call"
-
-
FunctionCall object { arguments, call_id, name, 4 more }A tool call to run a function. See the function calling guide for more information.
-
arguments: stringA JSON string of the arguments to pass to the function.
-
call_id: stringThe unique ID of the function tool call generated by the model.
-
name: stringThe name of the function to run.
-
type: "function_call"The type of the function tool call. Always
function_call."function_call"
-
id: optional stringThe unique ID of the function tool call.
-
namespace: optional stringThe namespace of the function to run.
-
status: optional "in_progress" or "completed" or "incomplete"The status of the item. One of
in_progress,completed, orincomplete. Populated when items are returned via API.-
"in_progress" -
"completed" -
"incomplete"
-
-
-
FunctionCallOutput object { call_id, output, type, 2 more }The output of a function tool call.
-
call_id: stringThe unique ID of the function tool call generated by the model.
-
output: string or array of ResponseInputTextContent or ResponseInputImageContent or ResponseInputFileContentText, image, or file output of the function tool call.
-
stringA JSON string of the output of the function tool call.
-
array of ResponseInputTextContent or ResponseInputImageContent or ResponseInputFileContentAn array of content outputs (text, image, file) for the function tool call.
-
ResponseInputTextContent object { text, type }A text input to the model.
-
text: stringThe text input to the model.
-
type: "input_text"The type of the input item. Always
input_text."input_text"
-
-
ResponseInputImageContent object { type, detail, file_id, image_url }An image input to the model. Learn about image inputs
-
type: "input_image"The type of the input item. Always
input_image."input_image"
-
detail: optional "low" or "high" or "auto" or "original"The detail level of the image to be sent to the model. One of
high,low,auto, ororiginal. Defaults toauto.-
"low" -
"high" -
"auto" -
"original"
-
-
file_id: optional stringThe ID of the file to be sent to the model.
-
image_url: optional stringThe URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.
-
-
ResponseInputFileContent object { type, detail, file_data, 3 more }A file input to the model.
-
type: "input_file"The type of the input item. Always
input_file."input_file"
-
detail: optional "low" or "high"The detail level of the file to be sent to the model. Use
lowfor the default rendering behavior, orhighto render the file at higher quality. Defaults tolow.-
"low" -
"high"
-
-
file_data: optional stringThe base64-encoded data of the file to be sent to the model.
-
file_id: optional stringThe ID of the file to be sent to the model.
-
file_url: optional stringThe URL of the file to be sent to the model.
-
filename: optional stringThe name of the file to be sent to the model.
-
-
-
-
type: "function_call_output"The type of the function tool call output. Always
function_call_output."function_call_output"
-
id: optional stringThe unique ID of the function tool call output. Populated when this item is returned via API.
-
status: optional "in_progress" or "completed" or "incomplete"The status of the item. One of
in_progress,completed, orincomplete. Populated when items are returned via API.-
"in_progress" -
"completed" -
"incomplete"
-
-
-
ToolSearchCall object { arguments, type, id, 3 more }-
arguments: unknownThe arguments supplied to the tool search call.
-
type: "tool_search_call"The item type. Always
tool_search_call."tool_search_call"
-
id: optional stringThe unique ID of this tool search call.
-
call_id: optional stringThe unique ID of the tool search call generated by the model.
-
execution: optional "server" or "client"Whether tool search was executed by the server or by the client.
-
"server" -
"client"
-
-
status: optional "in_progress" or "completed" or "incomplete"The status of the tool search call.
-
"in_progress" -
"completed" -
"incomplete"
-
-
-
ToolSearchOutput object { tools, type, id, 3 more }-
tools: array of object { name, parameters, strict, 3 more } or object { type, vector_store_ids, filters, 2 more } or object { type } or 12 moreThe loaded tool definitions returned by the tool search output.
-
Function object { name, parameters, strict, 3 more }Defines a function in your own code the model can choose to call. Learn more about function calling.
-
name: stringThe name of the function to call.
-
parameters: map[unknown]A JSON schema object describing the parameters of the function.
-
strict: booleanWhether to enforce strict parameter validation. Default
true. -
type: "function"The type of the function tool. Always
function."function"
-
defer_loading: optional booleanWhether this function is deferred and loaded via tool search.
-
description: optional stringA description of the function. Used by the model to determine whether or not to call the function.
-
-
FileSearch object { type, vector_store_ids, filters, 2 more }A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
-
type: "file_search"The type of the file search tool. Always
file_search."file_search"
-
vector_store_ids: array of stringThe IDs of the vector stores to search.
-
filters: optional ComparisonFilter or CompoundFilterA filter to apply.
-
ComparisonFilter object { key, type, value }A filter used to compare a specified attribute key to a given value using a defined comparison operation.
-
key: stringThe key to compare against the value.
-
type: "eq" or "ne" or "gt" or 5 moreSpecifies the comparison operator:
eq,ne,gt,gte,lt,lte,in,nin.-
eq: equals -
ne: not equal -
gt: greater than -
gte: greater than or equal -
lt: less than -
lte: less than or equal -
in: in -
nin: not in -
"eq" -
"ne" -
"gt" -
"gte" -
"lt" -
"lte" -
"in" -
"nin"
-
-
value: string or number or boolean or array of string or numberThe value to compare against the attribute key; supports string, number, or boolean types.
-
string -
number -
boolean -
array of string or number-
string -
number
-
-
-
-
CompoundFilter object { filters, type }Combine multiple filters using
andoror.-
filters: array of ComparisonFilter or unknownArray of filters to combine. Items can be
ComparisonFilterorCompoundFilter.-
ComparisonFilter object { key, type, value }A filter used to compare a specified attribute key to a given value using a defined comparison operation.
-
unknown
-
-
type: "and" or "or"Type of operation:
andoror.-
"and" -
"or"
-
-
-
-
max_num_results: optional numberThe maximum number of results to return. This number should be between 1 and 50 inclusive.
-
ranking_options: optional object { hybrid_search, ranker, score_threshold }Ranking options for search.
-
hybrid_search: optional object { embedding_weight, text_weight }Weights that control how reciprocal rank fusion balances semantic embedding matches versus sparse keyword matches when hybrid search is enabled.
-
embedding_weight: numberThe weight of the embedding in the reciprocal ranking fusion.
-
text_weight: numberThe weight of the text in the reciprocal ranking fusion.
-
-
ranker: optional "auto" or "default-2024-11-15"The ranker to use for the file search.
-
"auto" -
"default-2024-11-15"
-
-
score_threshold: optional numberThe score threshold for the file search, a number between 0 and 1. Numbers closer to 1 will attempt to return only the most relevant results, but may return fewer results.
-
-
-
Computer object { type }A tool that controls a virtual computer. Learn more about the computer tool.
-
type: "computer"The type of the computer tool. Always
computer."computer"
-
-
ComputerUsePreview object { display_height, display_width, environment, type }A tool that controls a virtual computer. Learn more about the computer tool.
-
display_height: numberThe height of the computer display.
-
display_width: numberThe width of the computer display.
-
environment: "windows" or "mac" or "linux" or 2 moreThe type of computer environment to control.
-
"windows" -
"mac" -
"linux" -
"ubuntu" -
"browser"
-
-
type: "computer_use_preview"The type of the computer use tool. Always
computer_use_preview."computer_use_preview"
-
-
WebSearch object { type, filters, search_context_size, user_location }Search the Internet for sources related to the prompt. Learn more about the web search tool.
-
type: "web_search" or "web_search_2025_08_26"The type of the web search tool. One of
web_searchorweb_search_2025_08_26.-
"web_search" -
"web_search_2025_08_26"
-
-
filters: optional object { allowed_domains }Filters for the search.
-
allowed_domains: optional array of stringAllowed domains for the search. If not provided, all domains are allowed. Subdomains of the provided domains are allowed as well.
Example:
["pubmed.ncbi.nlm.nih.gov"]
-
-
search_context_size: optional "low" or "medium" or "high"High level guidance for the amount of context window space to use for the search. One of
low,medium, orhigh.mediumis the default.-
"low" -
"medium" -
"high"
-
-
user_location: optional object { city, country, region, 2 more }The approximate location of the user.
-
city: optional stringFree text input for the city of the user, e.g.
San Francisco. -
country: optional stringThe two-letter ISO country code of the user, e.g.
US. -
region: optional stringFree text input for the region of the user, e.g.
California. -
timezone: optional stringThe IANA timezone of the user, e.g.
America/Los_Angeles. -
type: optional "approximate"The type of location approximation. Always
approximate."approximate"
-
-
-
Mcp object { server_label, type, allowed_tools, 7 more }Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP.
-
server_label: stringA label for this MCP server, used to identify it in tool calls.
-
type: "mcp"The type of the MCP tool. Always
mcp."mcp"
-
allowed_tools: optional array of string or object { read_only, tool_names }List of allowed tool names or a filter object.
-
McpAllowedTools = array of stringA string array of allowed tool names
-
McpToolFilter object { read_only, tool_names }A filter object to specify which tools are allowed.
-
read_only: optional booleanIndicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with
readOnlyHint, it will match this filter. -
tool_names: optional array of stringList of allowed tool names.
-
-
-
authorization: optional stringAn OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here.
-
connector_id: optional "connector_dropbox" or "connector_gmail" or "connector_googlecalendar" or 5 moreIdentifier for service connectors, like those available in ChatGPT. One of
server_urlorconnector_idmust be provided. Learn more about service connectors here.Currently supported
connector_idvalues are:-
Dropbox:
connector_dropbox -
Gmail:
connector_gmail -
Google Calendar:
connector_googlecalendar -
Google Drive:
connector_googledrive -
Microsoft Teams:
connector_microsoftteams -
Outlook Calendar:
connector_outlookcalendar -
Outlook Email:
connector_outlookemail -
SharePoint:
connector_sharepoint -
"connector_dropbox" -
"connector_gmail" -
"connector_googlecalendar" -
"connector_googledrive" -
"connector_microsoftteams" -
"connector_outlookcalendar" -
"connector_outlookemail" -
"connector_sharepoint"
-
-
defer_loading: optional booleanWhether this MCP tool is deferred and discovered via tool search.
-
headers: optional map[string]Optional HTTP headers to send to the MCP server. Use for authentication or other purposes.
-
require_approval: optional object { always, never } or "always" or "never"Specify which of the MCP server's tools require approval.
-
McpToolApprovalFilter object { always, never }Specify which of the MCP server's tools require approval. Can be
always,never, or a filter object associated with tools that require approval.-
always: optional object { read_only, tool_names }A filter object to specify which tools are allowed.
-
read_only: optional booleanIndicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with
readOnlyHint, it will match this filter. -
tool_names: optional array of stringList of allowed tool names.
-
-
never: optional object { read_only, tool_names }A filter object to specify which tools are allowed.
-
read_only: optional booleanIndicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with
readOnlyHint, it will match this filter. -
tool_names: optional array of stringList of allowed tool names.
-
-
-
McpToolApprovalSetting = "always" or "never"Specify a single approval policy for all tools. One of
alwaysornever. When set toalways, all tools will require approval. When set tonever, all tools will not require approval.-
"always" -
"never"
-
-
-
server_description: optional stringOptional description of the MCP server, used to provide more context.
-
server_url: optional stringThe URL for the MCP server. One of
server_urlorconnector_idmust be provided.
-
-
CodeInterpreter object { container, type }A tool that runs Python code to help generate a response to a prompt.
-
container: string or object { type, file_ids, memory_limit, network_policy }The code interpreter container. Can be a container ID or an object that specifies uploaded file IDs to make available to your code, along with an optional
memory_limitsetting.-
stringThe container ID.
-
CodeInterpreterToolAuto object { type, file_ids, memory_limit, network_policy }Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
-
type: "auto"Always
auto."auto"
-
file_ids: optional array of stringAn optional list of uploaded files to make available to your code.
-
memory_limit: optional "1g" or "4g" or "16g" or "64g"The memory limit for the code interpreter container.
-
"1g" -
"4g" -
"16g" -
"64g"
-
-
network_policy: optional ContainerNetworkPolicyDisabled or ContainerNetworkPolicyAllowlistNetwork access policy for the container.
-
ContainerNetworkPolicyDisabled object { type }-
type: "disabled"Disable outbound network access. Always
disabled."disabled"
-
-
ContainerNetworkPolicyAllowlist object { allowed_domains, type, domain_secrets }-
allowed_domains: array of stringA list of allowed domains when type is
allowlist. -
type: "allowlist"Allow outbound network access only to specified domains. Always
allowlist."allowlist"
-
domain_secrets: optional array of ContainerNetworkPolicyDomainSecretOptional domain-scoped secrets for allowlisted domains.
-
domain: stringThe domain associated with the secret.
-
name: stringThe name of the secret to inject for the domain.
-
value: stringThe secret value to inject for the domain.
-
-
-
-
-
-
type: "code_interpreter"The type of the code interpreter tool. Always
code_interpreter."code_interpreter"
-
-
ImageGeneration object { type, action, background, 9 more }A tool that generates images using the GPT image models.
-
type: "image_generation"The type of the image generation tool. Always
image_generation."image_generation"
-
action: optional "generate" or "edit" or "auto"Whether to generate a new image or edit an existing image. Default:
auto.-
"generate" -
"edit" -
"auto"
-
-
background: optional "transparent" or "opaque" or "auto"Background type for the generated image. One of
transparent,opaque, orauto. Default:auto.-
"transparent" -
"opaque" -
"auto"
-
-
input_fidelity: optional "high" or "low"Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for
gpt-image-1andgpt-image-1.5and later models, unsupported forgpt-image-1-mini. Supportshighandlow. Defaults tolow.-
"high" -
"low"
-
-
input_image_mask: optional object { file_id, image_url }Optional mask for inpainting. Contains
image_url(string, optional) andfile_id(string, optional).-
file_id: optional stringFile ID for the mask image.
-
image_url: optional stringBase64-encoded mask image.
-
-
model: optional string or "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-1.5"The image generation model to use. Default:
gpt-image-1.-
string -
"gpt-image-1" or "gpt-image-1-mini" or "gpt-image-1.5"The image generation model to use. Default:
gpt-image-1.-
"gpt-image-1" -
"gpt-image-1-mini" -
"gpt-image-1.5"
-
-
-
moderation: optional "auto" or "low"Moderation level for the generated image. Default:
auto.-
"auto" -
"low"
-
-
output_compression: optional numberCompression level for the output image. Default: 100.
-
output_format: optional "png" or "webp" or "jpeg"The output format of the generated image. One of
png,webp, orjpeg. Default:png.-
"png" -
"webp" -
"jpeg"
-
-
partial_images: optional numberNumber of partial images to generate in streaming mode, from 0 (default value) to 3.
-
quality: optional "low" or "medium" or "high" or "auto"The quality of the generated image. One of
low,medium,high, orauto. Default:auto.-
"low" -
"medium" -
"high" -
"auto"
-
-
size: optional string or "1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the generated images. For
gpt-image-2andgpt-image-2-2026-04-21, arbitrary resolutions are supported asWIDTHxHEIGHTstrings, for example1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above2560x1440are experimental, and the maximum supported resolution is3840x2160. The requested size must also satisfy the model's current pixel and edge limits. The standard sizes1024x1024,1536x1024, and1024x1536are supported by the GPT image models;autois supported for models that allow automatic sizing. Fordall-e-2, use one of256x256,512x512, or1024x1024. Fordall-e-3, use one of1024x1024,1792x1024, or1024x1792.-
string -
"1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the generated images. For
gpt-image-2andgpt-image-2-2026-04-21, arbitrary resolutions are supported asWIDTHxHEIGHTstrings, for example1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above2560x1440are experimental, and the maximum supported resolution is3840x2160. The requested size must also satisfy the model's current pixel and edge limits. The standard sizes1024x1024,1536x1024, and1024x1536are supported by the GPT image models;autois supported for models that allow automatic sizing. Fordall-e-2, use one of256x256,512x512, or1024x1024. Fordall-e-3, use one of1024x1024,1792x1024, or1024x1792.-
"1024x1024" -
"1024x1536" -
"1536x1024" -
"auto"
-
-
-
-
LocalShell object { type }A tool that allows the model to execute shell commands in a local environment.
-
type: "local_shell"The type of the local shell tool. Always
local_shell."local_shell"
-
-
Shell object { type, environment }A tool that allows the model to execute shell commands.
-
type: "shell"The type of the shell tool. Always
shell."shell"
-
environment: optional ContainerAuto or LocalEnvironment or ContainerReference-
ContainerAuto object { type, file_ids, memory_limit, 2 more }-
type: "container_auto"Automatically creates a container for this request
"container_auto"
-
file_ids: optional array of stringAn optional list of uploaded files to make available to your code.
-
memory_limit: optional "1g" or "4g" or "16g" or "64g"The memory limit for the container.
-
"1g" -
"4g" -
"16g" -
"64g"
-
-
network_policy: optional ContainerNetworkPolicyDisabled or ContainerNetworkPolicyAllowlistNetwork access policy for the container.
-
ContainerNetworkPolicyDisabled object { type } -
ContainerNetworkPolicyAllowlist object { allowed_domains, type, domain_secrets }
-
-
skills: optional array of SkillReference or InlineSkillAn optional list of skills referenced by id or inline data.
-
SkillReference object { skill_id, type, version }-
skill_id: stringThe ID of the referenced skill.
-
type: "skill_reference"References a skill created with the /v1/skills endpoint.
"skill_reference"
-
version: optional stringOptional skill version. Use a positive integer or 'latest'. Omit for default.
-
-
InlineSkill object { description, name, source, type }-
description: stringThe description of the skill.
-
name: stringThe name of the skill.
-
source: InlineSkillSourceInline skill payload
-
data: stringBase64-encoded skill zip bundle.
-
media_type: "application/zip"The media type of the inline skill payload. Must be
application/zip."application/zip"
-
type: "base64"The type of the inline skill source. Must be
base64."base64"
-
-
type: "inline"Defines an inline skill for this request.
"inline"
-
-
-
-
LocalEnvironment object { type, skills }-
type: "local"Use a local computer environment.
"local"
-
skills: optional array of LocalSkillAn optional list of skills.
-
description: stringThe description of the skill.
-
name: stringThe name of the skill.
-
path: stringThe path to the directory containing the skill.
-
-
-
ContainerReference object { container_id, type }-
container_id: stringThe ID of the referenced container.
-
type: "container_reference"References a container created with the /v1/containers endpoint
"container_reference"
-
-
-
-
Custom object { name, type, defer_loading, 2 more }A custom tool that processes input using a specified format. Learn more about custom tools
-
name: stringThe name of the custom tool, used to identify it in tool calls.
-
type: "custom"The type of the custom tool. Always
custom."custom"
-
defer_loading: optional booleanWhether this tool should be deferred and discovered via tool search.
-
description: optional stringOptional description of the custom tool, used to provide more context.
-
format: optional CustomToolInputFormatThe input format for the custom tool. Default is unconstrained text.
-
Text object { type }Unconstrained free-form text.
-
type: "text"Unconstrained text format. Always
text."text"
-
-
Grammar object { definition, syntax, type }A grammar defined by the user.
-
definition: stringThe grammar definition.
-
syntax: "lark" or "regex"The syntax of the grammar definition. One of
larkorregex.-
"lark" -
"regex"
-
-
type: "grammar"Grammar format. Always
grammar."grammar"
-
-
-
-
Namespace object { description, name, tools, type }Groups function/custom tools under a shared namespace.
-
description: stringA description of the namespace shown to the model.
-
name: stringThe namespace name used in tool calls (for example,
crm). -
tools: array of object { name, type, defer_loading, 3 more } or object { name, type, defer_loading, 2 more }The function/custom tools available inside this namespace.
-
Function object { name, type, defer_loading, 3 more }-
name: string -
type: "function""function"
-
defer_loading: optional booleanWhether this function should be deferred and discovered via tool search.
-
description: optional string -
parameters: optional unknown -
strict: optional boolean
-
-
Custom object { name, type, defer_loading, 2 more }A custom tool that processes input using a specified format. Learn more about custom tools
-
name: stringThe name of the custom tool, used to identify it in tool calls.
-
type: "custom"The type of the custom tool. Always
custom."custom"
-
defer_loading: optional booleanWhether this tool should be deferred and discovered via tool search.
-
description: optional stringOptional description of the custom tool, used to provide more context.
-
format: optional CustomToolInputFormatThe input format for the custom tool. Default is unconstrained text.
-
-
-
type: "namespace"The type of the tool. Always
namespace."namespace"
-
-
ToolSearch object { type, description, execution, parameters }Hosted or BYOT tool search configuration for deferred tools.
-
type: "tool_search"The type of the tool. Always
tool_search."tool_search"
-
description: optional stringDescription shown to the model for a client-executed tool search tool.
-
execution: optional "server" or "client"Whether tool search is executed by the server or by the client.
-
"server" -
"client"
-
-
parameters: optional unknownParameter schema for a client-executed tool search tool.
-
-
WebSearchPreview object { type, search_content_types, search_context_size, user_location }This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
-
type: "web_search_preview" or "web_search_preview_2025_03_11"The type of the web search tool. One of
web_search_previeworweb_search_preview_2025_03_11.-
"web_search_preview" -
"web_search_preview_2025_03_11"
-
-
search_content_types: optional array of "text" or "image"-
"text" -
"image"
-
-
search_context_size: optional "low" or "medium" or "high"High level guidance for the amount of context window space to use for the search. One of
low,medium, orhigh.mediumis the default.-
"low" -
"medium" -
"high"
-
-
user_location: optional object { type, city, country, 2 more }The user's location.
-
type: "approximate"The type of location approximation. Always
approximate."approximate"
-
city: optional stringFree text input for the city of the user, e.g.
San Francisco. -
country: optional stringThe two-letter ISO country code of the user, e.g.
US. -
region: optional stringFree text input for the region of the user, e.g.
California. -
timezone: optional stringThe IANA timezone of the user, e.g.
America/Los_Angeles.
-
-
-
ApplyPatch object { type }Allows the assistant to create, delete, or update files using unified diffs.
-
type: "apply_patch"The type of the tool. Always
apply_patch."apply_patch"
-
-
-
type: "tool_search_output"The item type. Always
tool_search_output."tool_search_output"
-
id: optional stringThe unique ID of this tool search output.
-
call_id: optional stringThe unique ID of the tool search call generated by the model.
-
execution: optional "server" or "client"Whether tool search was executed by the server or by the client.
-
"server" -
"client"
-
-
status: optional "in_progress" or "completed" or "incomplete"The status of the tool search output.
-
"in_progress" -
"completed" -
"incomplete"
-
-
-
Reasoning object { id, summary, type, 3 more }A description of the chain of thought used by a reasoning model while generating a response. Be sure to include these items in your
inputto the Responses API for subsequent turns of a conversation if you are manually managing context.-
id: stringThe unique identifier of the reasoning content.
-
summary: array of SummaryTextContentReasoning summary content.
-
text: stringA summary of the reasoning output from the model so far.
-
type: "summary_text"The type of the object. Always
summary_text."summary_text"
-
-
type: "reasoning"The type of the object. Always
reasoning."reasoning"
-
content: optional array of object { text, type }Reasoning text content.
-
text: stringThe reasoning text from the model.
-
type: "reasoning_text"The type of the reasoning text. Always
reasoning_text."reasoning_text"
-
-
encrypted_content: optional stringThe encrypted content of the reasoning item - populated when a response is generated with
reasoning.encrypted_contentin theincludeparameter. -
status: optional "in_progress" or "completed" or "incomplete"The status of the item. One of
in_progress,completed, orincomplete. Populated when items are returned via API.-
"in_progress" -
"completed" -
"incomplete"
-
-
-
Compaction object { encrypted_content, type, id }A compaction item generated by the
v1/responses/compactAPI.-
encrypted_content: stringThe encrypted content of the compaction summary.
-
type: "compaction"The type of the item. Always
compaction."compaction"
-
id: optional stringThe ID of the compaction item.
-
-
ImageGenerationCall object { id, result, status, type }An image generation request made by the model.
-
id: stringThe unique ID of the image generation call.
-
result: stringThe generated image encoded in base64.
-
status: "in_progress" or "completed" or "generating" or "failed"The status of the image generation call.
-
"in_progress" -
"completed" -
"generating" -
"failed"
-
-
type: "image_generation_call"The type of the image generation call. Always
image_generation_call."image_generation_call"
-
-
CodeInterpreterCall object { id, code, container_id, 3 more }A tool call to run code.
-
id: stringThe unique ID of the code interpreter tool call.
-
code: stringThe code to run, or null if not available.
-
container_id: stringThe ID of the container used to run the code.
-
outputs: array of object { logs, type } or object { type, url }The outputs generated by the code interpreter, such as logs or images. Can be null if no outputs are available.
-
Logs object { logs, type }The logs output from the code interpreter.
-
logs: stringThe logs output from the code interpreter.
-
type: "logs"The type of the output. Always
logs."logs"
-
-
Image object { type, url }The image output from the code interpreter.
-
type: "image"The type of the output. Always
image."image"
-
url: stringThe URL of the image output from the code interpreter.
-
-
-
status: "in_progress" or "completed" or "incomplete" or 2 moreThe status of the code interpreter tool call. Valid values are
in_progress,completed,incomplete,interpreting, andfailed.-
"in_progress" -
"completed" -
"incomplete" -
"interpreting" -
"failed"
-
-
type: "code_interpreter_call"The type of the code interpreter tool call. Always
code_interpreter_call."code_interpreter_call"
-
-
LocalShellCall object { id, action, call_id, 2 more }A tool call to run a command on the local shell.
-
id: stringThe unique ID of the local shell call.
-
action: object { command, env, type, 3 more }Execute a shell command on the server.
-
command: array of stringThe command to run.
-
env: map[string]Environment variables to set for the command.
-
type: "exec"The type of the local shell action. Always
exec."exec"
-
timeout_ms: optional numberOptional timeout in milliseconds for the command.
-
user: optional stringOptional user to run the command as.
-
working_directory: optional stringOptional working directory to run the command in.
-
-
call_id: stringThe unique ID of the local shell tool call generated by the model.
-
status: "in_progress" or "completed" or "incomplete"The status of the local shell call.
-
"in_progress" -
"completed" -
"incomplete"
-
-
type: "local_shell_call"The type of the local shell call. Always
local_shell_call."local_shell_call"
-
-
LocalShellCallOutput object { id, output, type, status }The output of a local shell tool call.
-
id: stringThe unique ID of the local shell tool call generated by the model.
-
output: stringA JSON string of the output of the local shell tool call.
-
type: "local_shell_call_output"The type of the local shell tool call output. Always
local_shell_call_output."local_shell_call_output"
-
status: optional "in_progress" or "completed" or "incomplete"The status of the item. One of
in_progress,completed, orincomplete.-
"in_progress" -
"completed" -
"incomplete"
-
-
-
ShellCall object { action, call_id, type, 3 more }A tool representing a request to execute one or more shell commands.
-
action: object { commands, max_output_length, timeout_ms }The shell commands and limits that describe how to run the tool call.
-
commands: array of stringOrdered shell commands for the execution environment to run.
-
max_output_length: optional numberMaximum number of UTF-8 characters to capture from combined stdout and stderr output.
-
timeout_ms: optional numberMaximum wall-clock time in milliseconds to allow the shell commands to run.
-
-
call_id: stringThe unique ID of the shell tool call generated by the model.
-
type: "shell_call"The type of the item. Always
shell_call."shell_call"
-
id: optional stringThe unique ID of the shell tool call. Populated when this item is returned via API.
-
environment: optional LocalEnvironment or ContainerReferenceThe environment to execute the shell commands in.
-
LocalEnvironment object { type, skills } -
ContainerReference object { container_id, type }
-
-
status: optional "in_progress" or "completed" or "incomplete"The status of the shell call. One of
in_progress,completed, orincomplete.-
"in_progress" -
"completed" -
"incomplete"
-
-
-
ShellCallOutput object { call_id, output, type, 3 more }The streamed output items emitted by a shell tool call.
-
call_id: stringThe unique ID of the shell tool call generated by the model.
-
output: array of ResponseFunctionShellCallOutputContentCaptured chunks of stdout and stderr output, along with their associated outcomes.
-
outcome: object { type } or object { exit_code, type }The exit or timeout outcome associated with this shell call.
-
Timeout object { type }Indicates that the shell call exceeded its configured time limit.
-
type: "timeout"The outcome type. Always
timeout."timeout"
-
-
Exit object { exit_code, type }Indicates that the shell commands finished and returned an exit code.
-
exit_code: numberThe exit code returned by the shell process.
-
type: "exit"The outcome type. Always
exit."exit"
-
-
-
stderr: stringCaptured stderr output for the shell call.
-
stdout: stringCaptured stdout output for the shell call.
-
-
type: "shell_call_output"The type of the item. Always
shell_call_output."shell_call_output"
-
id: optional stringThe unique ID of the shell tool call output. Populated when this item is returned via API.
-
max_output_length: optional numberThe maximum number of UTF-8 characters captured for this shell call's combined output.
-
status: optional "in_progress" or "completed" or "incomplete"The status of the shell call output.
-
"in_progress" -
"completed" -
"incomplete"
-
-
-
ApplyPatchCall object { call_id, operation, status, 2 more }A tool call representing a request to create, delete, or update files using diff patches.
-
call_id: stringThe unique ID of the apply patch tool call generated by the model.
-
operation: object { diff, path, type } or object { path, type } or object { diff, path, type }The specific create, delete, or update instruction for the apply_patch tool call.
-
CreateFile object { diff, path, type }Instruction for creating a new file via the apply_patch tool.
-
diff: stringUnified diff content to apply when creating the file.
-
path: stringPath of the file to create relative to the workspace root.
-
type: "create_file"The operation type. Always
create_file."create_file"
-
-
DeleteFile object { path, type }Instruction for deleting an existing file via the apply_patch tool.
-
path: stringPath of the file to delete relative to the workspace root.
-
type: "delete_file"The operation type. Always
delete_file."delete_file"
-
-
UpdateFile object { diff, path, type }Instruction for updating an existing file via the apply_patch tool.
-
diff: stringUnified diff content to apply to the existing file.
-
path: stringPath of the file to update relative to the workspace root.
-
type: "update_file"The operation type. Always
update_file."update_file"
-
-
-
status: "in_progress" or "completed"The status of the apply patch tool call. One of
in_progressorcompleted.-
"in_progress" -
"completed"
-
-
type: "apply_patch_call"The type of the item. Always
apply_patch_call."apply_patch_call"
-
id: optional stringThe unique ID of the apply patch tool call. Populated when this item is returned via API.
-
-
ApplyPatchCallOutput object { call_id, status, type, 2 more }The streamed output emitted by an apply patch tool call.
-
call_id: stringThe unique ID of the apply patch tool call generated by the model.
-
status: "completed" or "failed"The status of the apply patch tool call output. One of
completedorfailed.-
"completed" -
"failed"
-
-
type: "apply_patch_call_output"The type of the item. Always
apply_patch_call_output."apply_patch_call_output"
-
id: optional stringThe unique ID of the apply patch tool call output. Populated when this item is returned via API.
-
output: optional stringOptional human-readable log text from the apply patch tool (e.g., patch results or errors).
-
-
McpListTools object { id, server_label, tools, 2 more }A list of tools available on an MCP server.
-
id: stringThe unique ID of the list.
-
server_label: stringThe label of the MCP server.
-
tools: array of object { input_schema, name, annotations, description }The tools available on the server.
-
input_schema: unknownThe JSON schema describing the tool's input.
-
name: stringThe name of the tool.
-
annotations: optional unknownAdditional annotations about the tool.
-
description: optional stringThe description of the tool.
-
-
type: "mcp_list_tools"The type of the item. Always
mcp_list_tools."mcp_list_tools"
-
error: optional stringError message if the server could not list tools.
-
-
McpApprovalRequest object { id, arguments, name, 2 more }A request for human approval of a tool invocation.
-
id: stringThe unique ID of the approval request.
-
arguments: stringA JSON string of arguments for the tool.
-
name: stringThe name of the tool to run.
-
server_label: stringThe label of the MCP server making the request.
-
type: "mcp_approval_request"The type of the item. Always
mcp_approval_request."mcp_approval_request"
-
-
McpApprovalResponse object { approval_request_id, approve, type, 2 more }A response to an MCP approval request.
-
approval_request_id: stringThe ID of the approval request being answered.
-
approve: booleanWhether the request was approved.
-
type: "mcp_approval_response"The type of the item. Always
mcp_approval_response."mcp_approval_response"
-
id: optional stringThe unique ID of the approval response
-
reason: optional stringOptional reason for the decision.
-
-
McpCall object { id, arguments, name, 6 more }An invocation of a tool on an MCP server.
-
id: stringThe unique ID of the tool call.
-
arguments: stringA JSON string of the arguments passed to the tool.
-
name: stringThe name of the tool that was run.
-
server_label: stringThe label of the MCP server running the tool.
-
type: "mcp_call"The type of the item. Always
mcp_call."mcp_call"
-
approval_request_id: optional stringUnique identifier for the MCP tool call approval request. Include this value in a subsequent
mcp_approval_responseinput to approve or reject the corresponding tool call. -
error: optional stringThe error from the tool call, if any.
-
output: optional stringThe output from the tool call.
-
status: optional "in_progress" or "completed" or "incomplete" or 2 moreThe status of the tool call. One of
in_progress,completed,incomplete,calling, orfailed.-
"in_progress" -
"completed" -
"incomplete" -
"calling" -
"failed"
-
-
-
CustomToolCallOutput object { call_id, output, type, id }The output of a custom tool call from your code, being sent back to the model.
-
call_id: stringThe call ID, used to map this custom tool call output to a custom tool call.
-
output: string or array of ResponseInputText or ResponseInputImage or ResponseInputFileThe output from the custom tool call generated by your code. Can be a string or an list of output content.
-
StringOutput = stringA string of the output of the custom tool call.
-
OutputContentList = array of ResponseInputText or ResponseInputImage or ResponseInputFileText, image, or file output of the custom tool call.
-
ResponseInputText object { text, type }A text input to the model.
-
ResponseInputImage object { detail, type, file_id, image_url }An image input to the model. Learn about image inputs.
-
ResponseInputFile object { type, detail, file_data, 3 more }A file input to the model.
-
-
-
type: "custom_tool_call_output"The type of the custom tool call output. Always
custom_tool_call_output."custom_tool_call_output"
-
id: optional stringThe unique ID of the custom tool call output in the OpenAI platform.
-
-
CustomToolCall object { call_id, input, name, 3 more }A call to a custom tool created by the model.
-
call_id: stringAn identifier used to map this custom tool call to a tool call output.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool being called.
-
type: "custom_tool_call"The type of the custom tool call. Always
custom_tool_call."custom_tool_call"
-
id: optional stringThe unique ID of the custom tool call in the OpenAI platform.
-
namespace: optional stringThe namespace of the custom tool being called.
-
-
CompactionTrigger object { type }Compacts the current context. Must be the final input item.
-
type: "compaction_trigger"The type of the item. Always
compaction_trigger."compaction_trigger"
-
-
ItemReference object { id, type }An internal identifier for an item to reference.
-
id: stringThe ID of the item to reference.
-
type: optional "item_reference"The type of item to reference. Always
item_reference."item_reference"
-
-
-
instructions: optional stringA system (or developer) message inserted into the model's context.
When using along with
previous_response_id, the instructions from a previous response will not be carried over to the next response. This makes it simple to swap out system (or developer) messages in new responses. -
max_output_tokens: optional numberAn upper bound for the number of tokens that can be generated for a response, including visible output tokens and reasoning tokens.
-
max_tool_calls: optional numberThe maximum number of total calls to built-in tools that can be processed in a response. This maximum number applies across all built-in tool calls, not per individual tool. Any further attempts to call a tool by the model will be ignored.
-
metadata: optional MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
model: optional ResponsesModelModel ID used to generate the response, like
gpt-4ooro3. OpenAI offers a wide range of models with different capabilities, performance characteristics, and price points. Refer to the model guide to browse and compare available models.-
string -
"gpt-5.4" or "gpt-5.4-mini" or "gpt-5.4-nano" or 75 more-
"gpt-5.4" -
"gpt-5.4-mini" -
"gpt-5.4-nano" -
"gpt-5.4-mini-2026-03-17" -
"gpt-5.4-nano-2026-03-17" -
"gpt-5.3-chat-latest" -
"gpt-5.2" -
"gpt-5.2-2025-12-11" -
"gpt-5.2-chat-latest" -
"gpt-5.2-pro" -
"gpt-5.2-pro-2025-12-11" -
"gpt-5.1" -
"gpt-5.1-2025-11-13" -
"gpt-5.1-codex" -
"gpt-5.1-mini" -
"gpt-5.1-chat-latest" -
"gpt-5" -
"gpt-5-mini" -
"gpt-5-nano" -
"gpt-5-2025-08-07" -
"gpt-5-mini-2025-08-07" -
"gpt-5-nano-2025-08-07" -
"gpt-5-chat-latest" -
"gpt-4.1" -
"gpt-4.1-mini" -
"gpt-4.1-nano" -
"gpt-4.1-2025-04-14" -
"gpt-4.1-mini-2025-04-14" -
"gpt-4.1-nano-2025-04-14" -
"o4-mini" -
"o4-mini-2025-04-16" -
"o3" -
"o3-2025-04-16" -
"o3-mini" -
"o3-mini-2025-01-31" -
"o1" -
"o1-2024-12-17" -
"o1-preview" -
"o1-preview-2024-09-12" -
"o1-mini" -
"o1-mini-2024-09-12" -
"gpt-4o" -
"gpt-4o-2024-11-20" -
"gpt-4o-2024-08-06" -
"gpt-4o-2024-05-13" -
"gpt-4o-audio-preview" -
"gpt-4o-audio-preview-2024-10-01" -
"gpt-4o-audio-preview-2024-12-17" -
"gpt-4o-audio-preview-2025-06-03" -
"gpt-4o-mini-audio-preview" -
"gpt-4o-mini-audio-preview-2024-12-17" -
"gpt-4o-search-preview" -
"gpt-4o-mini-search-preview" -
"gpt-4o-search-preview-2025-03-11" -
"gpt-4o-mini-search-preview-2025-03-11" -
"chatgpt-4o-latest" -
"codex-mini-latest" -
"gpt-4o-mini" -
"gpt-4o-mini-2024-07-18" -
"gpt-4-turbo" -
"gpt-4-turbo-2024-04-09" -
"gpt-4-0125-preview" -
"gpt-4-turbo-preview" -
"gpt-4-1106-preview" -
"gpt-4-vision-preview" -
"gpt-4" -
"gpt-4-0314" -
"gpt-4-0613" -
"gpt-4-32k" -
"gpt-4-32k-0314" -
"gpt-4-32k-0613" -
"gpt-3.5-turbo" -
"gpt-3.5-turbo-16k" -
"gpt-3.5-turbo-0301" -
"gpt-3.5-turbo-0613" -
"gpt-3.5-turbo-1106" -
"gpt-3.5-turbo-0125" -
"gpt-3.5-turbo-16k-0613"
-
-
ResponsesOnlyModel = "o1-pro" or "o1-pro-2025-03-19" or "o3-pro" or 11 more-
"o1-pro" -
"o1-pro-2025-03-19" -
"o3-pro" -
"o3-pro-2025-06-10" -
"o3-deep-research" -
"o3-deep-research-2025-06-26" -
"o4-mini-deep-research" -
"o4-mini-deep-research-2025-06-26" -
"computer-use-preview" -
"computer-use-preview-2025-03-11" -
"gpt-5-codex" -
"gpt-5-pro" -
"gpt-5-pro-2025-10-06" -
"gpt-5.1-codex-max"
-
-
-
parallel_tool_calls: optional booleanWhether to allow the model to run tool calls in parallel.
-
previous_response_id: optional stringThe unique ID of the previous response to the model. Use this to create multi-turn conversations. Learn more about conversation state. Cannot be used in conjunction with
conversation. -
prompt: optional ResponsePromptReference to a prompt template and its variables. Learn more.
-
id: stringThe unique identifier of the prompt template to use.
-
variables: optional map[string or ResponseInputText or ResponseInputImage or ResponseInputFile]Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
-
string -
ResponseInputText object { text, type }A text input to the model.
-
ResponseInputImage object { detail, type, file_id, image_url }An image input to the model. Learn about image inputs.
-
ResponseInputFile object { type, detail, file_data, 3 more }A file input to the model.
-
-
version: optional stringOptional version of the prompt template.
-
-
prompt_cache_key: optional stringUsed by OpenAI to cache responses for similar requests to optimize your cache hit rates. Replaces the
userfield. Learn more. -
prompt_cache_retention: optional "in_memory" or "24h"The retention policy for the prompt cache. Set to
24hto enable extended prompt caching, which keeps cached prefixes active for longer, up to a maximum of 24 hours. Learn more.-
"in_memory" -
"24h"
-
-
reasoning: optional Reasoninggpt-5 and o-series models only
Configuration options for reasoning models.
-
effort: optional ReasoningEffortConstrains effort on reasoning for reasoning models. Currently supported values are
none,minimal,low,medium,high, andxhigh. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response.-
gpt-5.1defaults tonone, which does not perform reasoning. The supported reasoning values forgpt-5.1arenone,low,medium, andhigh. Tool calls are supported for all reasoning values in gpt-5.1. -
All models before
gpt-5.1default tomediumreasoning effort, and do not supportnone. -
The
gpt-5-promodel defaults to (and only supports)highreasoning effort. -
xhighis supported for all models aftergpt-5.1-codex-max. -
"none" -
"minimal" -
"low" -
"medium" -
"high" -
"xhigh"
-
-
generate_summary: optional "auto" or "concise" or "detailed"Deprecated: use
summaryinstead.A summary of the reasoning performed by the model. This can be useful for debugging and understanding the model's reasoning process. One of
auto,concise, ordetailed.-
"auto" -
"concise" -
"detailed"
-
-
summary: optional "auto" or "concise" or "detailed"A summary of the reasoning performed by the model. This can be useful for debugging and understanding the model's reasoning process. One of
auto,concise, ordetailed.conciseis supported forcomputer-use-previewmodels and all reasoning models aftergpt-5.-
"auto" -
"concise" -
"detailed"
-
-
-
safety_identifier: optional stringA stable identifier used to help detect users of your application that may be violating OpenAI's usage policies. The IDs should be a string that uniquely identifies each user, with a maximum length of 64 characters. We recommend hashing their username or email address, in order to avoid sending us any identifying information. Learn more.
-
service_tier: optional "auto" or "default" or "flex" or 2 moreSpecifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the
service_tierparameter is set, the response body will include theservice_tiervalue based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.-
"auto" -
"default" -
"flex" -
"scale" -
"priority"
-
store: optional booleanWhether to store the generated model response for later retrieval via API.
-
stream: optional booleanIf set to true, the model response data will be streamed to the client as it is generated using server-sent events. See the Streaming section below for more information.
-
stream_options: optional object { include_obfuscation }Options for streaming responses. Only set this when you set
stream: true.-
include_obfuscation: optional booleanWhen true, stream obfuscation will be enabled. Stream obfuscation adds random characters to an
obfuscationfield on streaming delta events to normalize payload sizes as a mitigation to certain side-channel attacks. These obfuscation fields are included by default, but add a small amount of overhead to the data stream. You can setinclude_obfuscationto false to optimize for bandwidth if you trust the network links between your application and the OpenAI API.
-
-
temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or
top_pbut not both. -
text: optional ResponseTextConfigConfiguration options for a text response from the model. Can be plain text or structured JSON data. Learn more:
-
format: optional ResponseFormatTextConfigAn object specifying the format that the model must output.
Configuring
{ "type": "json_schema" }enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.The default format is
{ "type": "text" }with no additional options.Not recommended for gpt-4o and newer models:
Setting to
{ "type": "json_object" }enables the older JSON mode, which ensures the message the model generates is valid JSON. Usingjson_schemais preferred for models that support it.-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatTextJSONSchemaConfig object { name, schema, type, 2 more }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
schema: map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
-
verbosity: optional "low" or "medium" or "high"Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are
low,medium, andhigh.-
"low" -
"medium" -
"high"
-
-
tool_choice: optional ToolChoiceOptions or ToolChoiceAllowed or ToolChoiceTypes or 5 moreHow the model should select which tool (or tools) to use when generating a response. See the
toolsparameter to see how to specify which tools the model can call.-
ToolChoiceOptions = "none" or "auto" or "required"Controls which (if any) tool is called by the model.
nonemeans the model will not call any tool and instead generates a message.automeans the model can pick between generating a message or calling one or more tools.requiredmeans the model must call one or more tools.-
"none" -
"auto" -
"required"
-
-
ToolChoiceAllowed object { mode, tools, type }Constrains the tools available to the model to a pre-defined set.
-
mode: "auto" or "required"Constrains the tools available to the model to a pre-defined set.
autoallows the model to pick from among the allowed tools and generate a message.requiredrequires the model to call one or more of the allowed tools.-
"auto" -
"required"
-
-
tools: array of map[unknown]A list of tool definitions that the model should be allowed to call.
For the Responses API, the list of tool definitions might look like:
[ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ] -
type: "allowed_tools"Allowed tool configuration type. Always
allowed_tools."allowed_tools"
-
-
ToolChoiceTypes object { type }Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
-
type: "file_search" or "web_search_preview" or "computer" or 5 moreThe type of hosted tool the model should to use. Learn more about built-in tools.
Allowed values are:
-
file_search -
web_search_preview -
computer -
computer_use_preview -
computer_use -
code_interpreter -
image_generation -
"file_search" -
"web_search_preview" -
"computer" -
"computer_use_preview" -
"computer_use" -
"web_search_preview_2025_03_11" -
"image_generation" -
"code_interpreter"
-
-
-
ToolChoiceFunction object { name, type }Use this option to force the model to call a specific function.
-
name: stringThe name of the function to call.
-
type: "function"For function calling, the type is always
function."function"
-
-
ToolChoiceMcp object { server_label, type, name }Use this option to force the model to call a specific tool on a remote MCP server.
-
server_label: stringThe label of the MCP server to use.
-
type: "mcp"For MCP tools, the type is always
mcp."mcp"
-
name: optional stringThe name of the tool to call on the server.
-
-
ToolChoiceCustom object { name, type }Use this option to force the model to call a specific custom tool.
-
name: stringThe name of the custom tool to call.
-
type: "custom"For custom tool calling, the type is always
custom."custom"
-
-
ToolChoiceApplyPatch object { type }Forces the model to call the apply_patch tool when executing a tool call.
-
type: "apply_patch"The tool to call. Always
apply_patch."apply_patch"
-
-
ToolChoiceShell object { type }Forces the model to call the shell tool when a tool call is required.
-
type: "shell"The tool to call. Always
shell."shell"
-
-
-
tools: optional array of object { name, parameters, strict, 3 more } or object { type, vector_store_ids, filters, 2 more } or object { type } or 12 moreAn array of tools the model may call while generating a response. You can specify which tool to use by setting the
tool_choiceparameter.We support the following categories of tools:
-
Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools.
-
MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools.
-
Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
-
Function object { name, parameters, strict, 3 more }Defines a function in your own code the model can choose to call. Learn more about function calling.
-
name: stringThe name of the function to call.
-
parameters: map[unknown]A JSON schema object describing the parameters of the function.
-
strict: booleanWhether to enforce strict parameter validation. Default
true. -
type: "function"The type of the function tool. Always
function."function"
-
defer_loading: optional booleanWhether this function is deferred and loaded via tool search.
-
description: optional stringA description of the function. Used by the model to determine whether or not to call the function.
-
-
FileSearch object { type, vector_store_ids, filters, 2 more }A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
-
type: "file_search"The type of the file search tool. Always
file_search."file_search"
-
vector_store_ids: array of stringThe IDs of the vector stores to search.
-
filters: optional ComparisonFilter or CompoundFilterA filter to apply.
-
ComparisonFilter object { key, type, value }A filter used to compare a specified attribute key to a given value using a defined comparison operation.
-
CompoundFilter object { filters, type }Combine multiple filters using
andoror.
-
-
max_num_results: optional numberThe maximum number of results to return. This number should be between 1 and 50 inclusive.
-
ranking_options: optional object { hybrid_search, ranker, score_threshold }Ranking options for search.
-
hybrid_search: optional object { embedding_weight, text_weight }Weights that control how reciprocal rank fusion balances semantic embedding matches versus sparse keyword matches when hybrid search is enabled.
-
embedding_weight: numberThe weight of the embedding in the reciprocal ranking fusion.
-
text_weight: numberThe weight of the text in the reciprocal ranking fusion.
-
-
ranker: optional "auto" or "default-2024-11-15"The ranker to use for the file search.
-
"auto" -
"default-2024-11-15"
-
-
score_threshold: optional numberThe score threshold for the file search, a number between 0 and 1. Numbers closer to 1 will attempt to return only the most relevant results, but may return fewer results.
-
-
-
Computer object { type }A tool that controls a virtual computer. Learn more about the computer tool.
-
type: "computer"The type of the computer tool. Always
computer."computer"
-
-
ComputerUsePreview object { display_height, display_width, environment, type }A tool that controls a virtual computer. Learn more about the computer tool.
-
display_height: numberThe height of the computer display.
-
display_width: numberThe width of the computer display.
-
environment: "windows" or "mac" or "linux" or 2 moreThe type of computer environment to control.
-
"windows" -
"mac" -
"linux" -
"ubuntu" -
"browser"
-
-
type: "computer_use_preview"The type of the computer use tool. Always
computer_use_preview."computer_use_preview"
-
-
WebSearch object { type, filters, search_context_size, user_location }Search the Internet for sources related to the prompt. Learn more about the web search tool.
-
type: "web_search" or "web_search_2025_08_26"The type of the web search tool. One of
web_searchorweb_search_2025_08_26.-
"web_search" -
"web_search_2025_08_26"
-
-
filters: optional object { allowed_domains }Filters for the search.
-
allowed_domains: optional array of stringAllowed domains for the search. If not provided, all domains are allowed. Subdomains of the provided domains are allowed as well.
Example:
["pubmed.ncbi.nlm.nih.gov"]
-
-
search_context_size: optional "low" or "medium" or "high"High level guidance for the amount of context window space to use for the search. One of
low,medium, orhigh.mediumis the default.-
"low" -
"medium" -
"high"
-
-
user_location: optional object { city, country, region, 2 more }The approximate location of the user.
-
city: optional stringFree text input for the city of the user, e.g.
San Francisco. -
country: optional stringThe two-letter ISO country code of the user, e.g.
US. -
region: optional stringFree text input for the region of the user, e.g.
California. -
timezone: optional stringThe IANA timezone of the user, e.g.
America/Los_Angeles. -
type: optional "approximate"The type of location approximation. Always
approximate."approximate"
-
-
-
Mcp object { server_label, type, allowed_tools, 7 more }Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP.
-
server_label: stringA label for this MCP server, used to identify it in tool calls.
-
type: "mcp"The type of the MCP tool. Always
mcp."mcp"
-
allowed_tools: optional array of string or object { read_only, tool_names }List of allowed tool names or a filter object.
-
McpAllowedTools = array of stringA string array of allowed tool names
-
McpToolFilter object { read_only, tool_names }A filter object to specify which tools are allowed.
-
read_only: optional booleanIndicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with
readOnlyHint, it will match this filter. -
tool_names: optional array of stringList of allowed tool names.
-
-
-
authorization: optional stringAn OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here.
-
connector_id: optional "connector_dropbox" or "connector_gmail" or "connector_googlecalendar" or 5 moreIdentifier for service connectors, like those available in ChatGPT. One of
server_urlorconnector_idmust be provided. Learn more about service connectors here.Currently supported
connector_idvalues are:-
Dropbox:
connector_dropbox -
Gmail:
connector_gmail -
Google Calendar:
connector_googlecalendar -
Google Drive:
connector_googledrive -
Microsoft Teams:
connector_microsoftteams -
Outlook Calendar:
connector_outlookcalendar -
Outlook Email:
connector_outlookemail -
SharePoint:
connector_sharepoint -
"connector_dropbox" -
"connector_gmail" -
"connector_googlecalendar" -
"connector_googledrive" -
"connector_microsoftteams" -
"connector_outlookcalendar" -
"connector_outlookemail" -
"connector_sharepoint"
-
-
defer_loading: optional booleanWhether this MCP tool is deferred and discovered via tool search.
-
headers: optional map[string]Optional HTTP headers to send to the MCP server. Use for authentication or other purposes.
-
require_approval: optional object { always, never } or "always" or "never"Specify which of the MCP server's tools require approval.
-
McpToolApprovalFilter object { always, never }Specify which of the MCP server's tools require approval. Can be
always,never, or a filter object associated with tools that require approval.-
always: optional object { read_only, tool_names }A filter object to specify which tools are allowed.
-
read_only: optional booleanIndicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with
readOnlyHint, it will match this filter. -
tool_names: optional array of stringList of allowed tool names.
-
-
never: optional object { read_only, tool_names }A filter object to specify which tools are allowed.
-
read_only: optional booleanIndicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with
readOnlyHint, it will match this filter. -
tool_names: optional array of stringList of allowed tool names.
-
-
-
McpToolApprovalSetting = "always" or "never"Specify a single approval policy for all tools. One of
alwaysornever. When set toalways, all tools will require approval. When set tonever, all tools will not require approval.-
"always" -
"never"
-
-
-
server_description: optional stringOptional description of the MCP server, used to provide more context.
-
server_url: optional stringThe URL for the MCP server. One of
server_urlorconnector_idmust be provided.
-
-
CodeInterpreter object { container, type }A tool that runs Python code to help generate a response to a prompt.
-
container: string or object { type, file_ids, memory_limit, network_policy }The code interpreter container. Can be a container ID or an object that specifies uploaded file IDs to make available to your code, along with an optional
memory_limitsetting.-
stringThe container ID.
-
CodeInterpreterToolAuto object { type, file_ids, memory_limit, network_policy }Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
-
type: "auto"Always
auto."auto"
-
file_ids: optional array of stringAn optional list of uploaded files to make available to your code.
-
memory_limit: optional "1g" or "4g" or "16g" or "64g"The memory limit for the code interpreter container.
-
"1g" -
"4g" -
"16g" -
"64g"
-
-
network_policy: optional ContainerNetworkPolicyDisabled or ContainerNetworkPolicyAllowlistNetwork access policy for the container.
-
ContainerNetworkPolicyDisabled object { type } -
ContainerNetworkPolicyAllowlist object { allowed_domains, type, domain_secrets }
-
-
-
-
type: "code_interpreter"The type of the code interpreter tool. Always
code_interpreter."code_interpreter"
-
-
ImageGeneration object { type, action, background, 9 more }A tool that generates images using the GPT image models.
-
type: "image_generation"The type of the image generation tool. Always
image_generation."image_generation"
-
action: optional "generate" or "edit" or "auto"Whether to generate a new image or edit an existing image. Default:
auto.-
"generate" -
"edit" -
"auto"
-
-
background: optional "transparent" or "opaque" or "auto"Background type for the generated image. One of
transparent,opaque, orauto. Default:auto.-
"transparent" -
"opaque" -
"auto"
-
-
input_fidelity: optional "high" or "low"Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for
gpt-image-1andgpt-image-1.5and later models, unsupported forgpt-image-1-mini. Supportshighandlow. Defaults tolow.-
"high" -
"low"
-
-
input_image_mask: optional object { file_id, image_url }Optional mask for inpainting. Contains
image_url(string, optional) andfile_id(string, optional).-
file_id: optional stringFile ID for the mask image.
-
image_url: optional stringBase64-encoded mask image.
-
-
model: optional string or "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-1.5"The image generation model to use. Default:
gpt-image-1.-
string -
"gpt-image-1" or "gpt-image-1-mini" or "gpt-image-1.5"The image generation model to use. Default:
gpt-image-1.-
"gpt-image-1" -
"gpt-image-1-mini" -
"gpt-image-1.5"
-
-
-
moderation: optional "auto" or "low"Moderation level for the generated image. Default:
auto.-
"auto" -
"low"
-
-
output_compression: optional numberCompression level for the output image. Default: 100.
-
output_format: optional "png" or "webp" or "jpeg"The output format of the generated image. One of
png,webp, orjpeg. Default:png.-
"png" -
"webp" -
"jpeg"
-
-
partial_images: optional numberNumber of partial images to generate in streaming mode, from 0 (default value) to 3.
-
quality: optional "low" or "medium" or "high" or "auto"The quality of the generated image. One of
low,medium,high, orauto. Default:auto.-
"low" -
"medium" -
"high" -
"auto"
-
-
size: optional string or "1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the generated images. For
gpt-image-2andgpt-image-2-2026-04-21, arbitrary resolutions are supported asWIDTHxHEIGHTstrings, for example1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above2560x1440are experimental, and the maximum supported resolution is3840x2160. The requested size must also satisfy the model's current pixel and edge limits. The standard sizes1024x1024,1536x1024, and1024x1536are supported by the GPT image models;autois supported for models that allow automatic sizing. Fordall-e-2, use one of256x256,512x512, or1024x1024. Fordall-e-3, use one of1024x1024,1792x1024, or1024x1792.-
string -
"1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the generated images. For
gpt-image-2andgpt-image-2-2026-04-21, arbitrary resolutions are supported asWIDTHxHEIGHTstrings, for example1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above2560x1440are experimental, and the maximum supported resolution is3840x2160. The requested size must also satisfy the model's current pixel and edge limits. The standard sizes1024x1024,1536x1024, and1024x1536are supported by the GPT image models;autois supported for models that allow automatic sizing. Fordall-e-2, use one of256x256,512x512, or1024x1024. Fordall-e-3, use one of1024x1024,1792x1024, or1024x1792.-
"1024x1024" -
"1024x1536" -
"1536x1024" -
"auto"
-
-
-
-
LocalShell object { type }A tool that allows the model to execute shell commands in a local environment.
-
type: "local_shell"The type of the local shell tool. Always
local_shell."local_shell"
-
-
Shell object { type, environment }A tool that allows the model to execute shell commands.
-
type: "shell"The type of the shell tool. Always
shell."shell"
-
environment: optional ContainerAuto or LocalEnvironment or ContainerReference-
ContainerAuto object { type, file_ids, memory_limit, 2 more } -
LocalEnvironment object { type, skills } -
ContainerReference object { container_id, type }
-
-
-
Custom object { name, type, defer_loading, 2 more }A custom tool that processes input using a specified format. Learn more about custom tools
-
name: stringThe name of the custom tool, used to identify it in tool calls.
-
type: "custom"The type of the custom tool. Always
custom."custom"
-
defer_loading: optional booleanWhether this tool should be deferred and discovered via tool search.
-
description: optional stringOptional description of the custom tool, used to provide more context.
-
format: optional CustomToolInputFormatThe input format for the custom tool. Default is unconstrained text.
-
-
Namespace object { description, name, tools, type }Groups function/custom tools under a shared namespace.
-
description: stringA description of the namespace shown to the model.
-
name: stringThe namespace name used in tool calls (for example,
crm). -
tools: array of object { name, type, defer_loading, 3 more } or object { name, type, defer_loading, 2 more }The function/custom tools available inside this namespace.
-
Function object { name, type, defer_loading, 3 more }-
name: string -
type: "function""function"
-
defer_loading: optional booleanWhether this function should be deferred and discovered via tool search.
-
description: optional string -
parameters: optional unknown -
strict: optional boolean
-
-
Custom object { name, type, defer_loading, 2 more }A custom tool that processes input using a specified format. Learn more about custom tools
-
name: stringThe name of the custom tool, used to identify it in tool calls.
-
type: "custom"The type of the custom tool. Always
custom."custom"
-
defer_loading: optional booleanWhether this tool should be deferred and discovered via tool search.
-
description: optional stringOptional description of the custom tool, used to provide more context.
-
format: optional CustomToolInputFormatThe input format for the custom tool. Default is unconstrained text.
-
-
-
type: "namespace"The type of the tool. Always
namespace."namespace"
-
-
ToolSearch object { type, description, execution, parameters }Hosted or BYOT tool search configuration for deferred tools.
-
type: "tool_search"The type of the tool. Always
tool_search."tool_search"
-
description: optional stringDescription shown to the model for a client-executed tool search tool.
-
execution: optional "server" or "client"Whether tool search is executed by the server or by the client.
-
"server" -
"client"
-
-
parameters: optional unknownParameter schema for a client-executed tool search tool.
-
-
WebSearchPreview object { type, search_content_types, search_context_size, user_location }This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
-
type: "web_search_preview" or "web_search_preview_2025_03_11"The type of the web search tool. One of
web_search_previeworweb_search_preview_2025_03_11.-
"web_search_preview" -
"web_search_preview_2025_03_11"
-
-
search_content_types: optional array of "text" or "image"-
"text" -
"image"
-
-
search_context_size: optional "low" or "medium" or "high"High level guidance for the amount of context window space to use for the search. One of
low,medium, orhigh.mediumis the default.-
"low" -
"medium" -
"high"
-
-
user_location: optional object { type, city, country, 2 more }The user's location.
-
type: "approximate"The type of location approximation. Always
approximate."approximate"
-
city: optional stringFree text input for the city of the user, e.g.
San Francisco. -
country: optional stringThe two-letter ISO country code of the user, e.g.
US. -
region: optional stringFree text input for the region of the user, e.g.
California. -
timezone: optional stringThe IANA timezone of the user, e.g.
America/Los_Angeles.
-
-
-
ApplyPatch object { type }Allows the assistant to create, delete, or update files using unified diffs.
-
type: "apply_patch"The type of the tool. Always
apply_patch."apply_patch"
-
-
-
top_logprobs: optional numberAn integer between 0 and 20 specifying the maximum number of most likely tokens to return at each token position, each with an associated log probability. In some cases, the number of returned tokens may be fewer than requested.
-
top_p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or
temperaturebut not both. -
truncation: optional "auto" or "disabled"The truncation strategy to use for the model response.
-
auto: If the input to this Response exceeds the model's context window size, the model will truncate the response to fit the context window by dropping items from the beginning of the conversation. -
disabled(default): If the input size will exceed the context window size for a model, the request will fail with a 400 error. -
"auto" -
"disabled"
-
-
user: optional stringThis field is being replaced by
safety_identifierandprompt_cache_key. Useprompt_cache_keyinstead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
Returns
-
Response object { id, created_at, error, 30 more }-
id: stringUnique identifier for this Response.
-
created_at: numberUnix timestamp (in seconds) of when this Response was created.
-
error: ResponseErrorAn error object returned when the model fails to generate a Response.
-
code: "server_error" or "rate_limit_exceeded" or "invalid_prompt" or 15 moreThe error code for the response.
-
"server_error" -
"rate_limit_exceeded" -
"invalid_prompt" -
"vector_store_timeout" -
"invalid_image" -
"invalid_image_format" -
"invalid_base64_image" -
"invalid_image_url" -
"image_too_large" -
"image_too_small" -
"image_parse_error" -
"image_content_policy_violation" -
"invalid_image_mode" -
"image_file_too_large" -
"unsupported_image_media_type" -
"empty_image_file" -
"failed_to_download_image" -
"image_file_not_found"
-
-
message: stringA human-readable description of the error.
-
-
incomplete_details: object { reason }Details about why the response is incomplete.
-
reason: optional "max_output_tokens" or "content_filter"The reason why the response is incomplete.
-
"max_output_tokens" -
"content_filter"
-
-
-
instructions: string or array of EasyInputMessage or object { content, role, status, type } or ResponseOutputMessage or 26 moreA system (or developer) message inserted into the model's context.
When using along with
previous_response_id, the instructions from a previous response will not be carried over to the next response. This makes it simple to swap out system (or developer) messages in new responses.-
stringA text input to the model, equivalent to a text input with the
developerrole. -
InputItemList = array of EasyInputMessage or object { content, role, status, type } or ResponseOutputMessage or 26 moreA list of one or many input items to the model, containing different content types.
-
EasyInputMessage object { content, role, phase, type }A message input to the model with a role indicating instruction following hierarchy. Instructions given with the
developerorsystemrole take precedence over instructions given with theuserrole. Messages with theassistantrole are presumed to have been generated by the model in previous interactions.-
content: string or ResponseInputMessageContentListText, image, or audio input to the model, used to generate a response. Can also contain previous assistant responses.
-
TextInput = stringA text input to the model.
-
ResponseInputMessageContentList = array of ResponseInputContentA list of one or many input items to the model, containing different content types.
-
ResponseInputText object { text, type }A text input to the model.
-
text: stringThe text input to the model.
-
type: "input_text"The type of the input item. Always
input_text."input_text"
-
-
ResponseInputImage object { detail, type, file_id, image_url }An image input to the model. Learn about image inputs.
-
detail: "low" or "high" or "auto" or "original"The detail level of the image to be sent to the model. One of
high,low,auto, ororiginal. Defaults toauto.-
"low" -
"high" -
"auto" -
"original"
-
-
type: "input_image"The type of the input item. Always
input_image."input_image"
-
file_id: optional stringThe ID of the file to be sent to the model.
-
image_url: optional stringThe URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.
-
-
ResponseInputFile object { type, detail, file_data, 3 more }A file input to the model.
-
type: "input_file"The type of the input item. Always
input_file."input_file"
-
detail: optional "low" or "high"The detail level of the file to be sent to the model. Use
lowfor the default rendering behavior, orhighto render the file at higher quality. Defaults tolow.-
"low" -
"high"
-
-
file_data: optional stringThe content of the file to be sent to the model.
-
file_id: optional stringThe ID of the file to be sent to the model.
-
file_url: optional stringThe URL of the file to be sent to the model.
-
filename: optional stringThe name of the file to be sent to the model.
-
-
-
-
role: "user" or "assistant" or "system" or "developer"The role of the message input. One of
user,assistant,system, ordeveloper.-
"user" -
"assistant" -
"system" -
"developer"
-
-
phase: optional "commentary" or "final_answer"Labels an
assistantmessage as intermediate commentary (commentary) or the final answer (final_answer). For models likegpt-5.3-codexand beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.-
"commentary" -
"final_answer"
-
-
type: optional "message"The type of the message input. Always
message."message"
-
-
Message object { content, role, status, type }A message input to the model with a role indicating instruction following hierarchy. Instructions given with the
developerorsystemrole take precedence over instructions given with theuserrole.-
content: ResponseInputMessageContentListA list of one or many input items to the model, containing different content types.
-
role: "user" or "system" or "developer"The role of the message input. One of
user,system, ordeveloper.-
"user" -
"system" -
"developer"
-
-
status: optional "in_progress" or "completed" or "incomplete"The status of item. One of
in_progress,completed, orincomplete. Populated when items are returned via API.-
"in_progress" -
"completed" -
"incomplete"
-
-
type: optional "message"The type of the message input. Always set to
message."message"
-
-
ResponseOutputMessage object { id, content, role, 3 more }An output message from the model.
-
id: stringThe unique ID of the output message.
-
content: array of ResponseOutputText or ResponseOutputRefusalThe content of the output message.
-
ResponseOutputText object { annotations, logprobs, text, type }A text output from the model.
-
[...]
